function [J, maxI] = comp_intKL(YYtrue, YYhat, Ngrid)

vec_om = 0:(pi/Ngrid):pi;
i = sqrt(-1);

Finv0 = YYtrue{1};
Ginv0 = YYhat{1};
Finv = Finv0;
Ginv = Ginv0;

vec_I = zeros(size(vec_om));
for ind=1:length(vec_om),
    om = vec_om(ind);
    for k=2:size(YYtrue,2),
        Finv = Finv + exp(-i*om*(k-1))*YYtrue{k} +exp(i*om*(k-1))*transpose(YYtrue{k});
    end
    for k=2:size(YYhat,2),
        Ginv = Ginv + exp(-i*om*(k-1))*YYhat{k} +exp(i*om*(k-1))*transpose(YYhat{k});
    end
    I = compKL(Finv,Ginv);
    vec_I(ind) = I;
    Finv = Finv0;
    Ginv = Ginv0;
end

J = sum(vec_I)/Ngrid;
maxI = max(vec_I);


% figure(1)
% plot(vec_om,vec_I);
% sum(vec_I)/Ngrid - vec_I(1)/2/Ngrid
% pause

end %function comp_intKL

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function I = compKL( Finv,Ginv )

P = Finv\Ginv;
L = real(eig(P));
if min(L)<0,
    fprintf('Error. The matrix is not PD!\n');
end
vec1 = log(L);
vec2 = -L + 1;
I = -sum(vec1+vec2)/2;

end

