function draw_graphs_KL

close all

load Result_KL_100runs.mat

ptrue = 10;

%Computation of J,J2 when RNML estimates correctly the order
for ind_N = 1:length(vec_N),
   ff = find(ord{3,ind_N}==ptrue);
   for crit=1:NoCrit,
    Jtr{crit,ind_N} = J{crit,ind_N}(ff);
    Jtr2{crit,ind_N} = J2{crit,ind_N}(ff);
   end
end

plot_ebar(vec_N, NoCrit, Imax, Imax2, 1);
plot_ebar(vec_N, NoCrit, J, J2, 2);
plot_ebar(vec_N, NoCrit, Jtr, Jtr2, 3);


end %function

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plot_ebar(vec_N, NoCrit, Imax, Imax2, flag)

for ind_N = 1:length(vec_N),
   for crit = 1:NoCrit,
       Imax_mat(crit,:) = Imax{crit,ind_N};
       Imax_mat2(crit,:) = Imax2{crit,ind_N};
   end
       mm = mean(Imax_mat,2);
       ee = std(Imax_mat,1,2);
       mm2 = mean(Imax_mat2,2);
       ee2 = std(Imax_mat2,1,2);
       
       mmtot = zeros(length(mm)+length(mm2),1);
       eetot = mmtot;
       
       mmtot(1:2:end) = mm;
       mmtot(2:2:end) = mm2;
       
       eetot(1:2:end) = ee;
       eetot(2:2:end) = ee2;
       
       figure
       if flag==1,
        errorbar(mmtot,eetot,'bx');
        ylabel('Imax');
       elseif flag==2,
         errorbar(mmtot,eetot,'rx');
          ylabel('J');
       elseif flag==3,
         errorbar(mmtot,eetot,'kx');
          ylabel('J constrained');
       else
       end
       set(gca,'XTick',1:2*NoCrit);
       set(gca,'XTickLabel',{'SBC','','FPE','','RNML','','AIC','','AICc','','KIC','','KICc',''})
       tit = sprintf('T=%i',vec_N(ind_N));
       title(tit);
       clear Imax_mat;
       clear Imax_mat2;
end

end %function